#include "MyRunAction.hh"
#include "G4Run.hh"
#include "MyRun.hh"
#include "globals.hh"
#include "TH1.h"
#include "TFile.h"


MyRunAction::MyRunAction() 
{}

MyRunAction::~MyRunAction() 
{}


void MyRunAction::BeginOfRunAction(const G4Run* aRun)
{
 G4cout << "MyLog:   Begin of run" << G4endl;
}

void MyRunAction::EndOfRunAction(const G4Run* aRun)
{

//..Output file for histograms
  TFile   *HistFile = new TFile("hist.root","RECREATE");

//..histograms definitions
  TH1D  *PhotonFlux = new TH1D("PhotonFlux","photon flow versus theta ",15,0.,90.);
 
  MyRun* theRun = (MyRun*) aRun;
  G4cout << "MyLog: number of map entries in run: " << theRun->frunHitsMap.entries() << G4endl;

  std::map<int,double*>::iterator iter;
  iter = theRun->frunHitsMap.GetMap()->begin();
  while( iter != theRun->frunHitsMap.GetMap()->end() ) {

//..set histogram content 
  PhotonFlux->SetBinContent(iter->first+1,*iter->second);

  G4cout<< "MyLog:      value of HitsMap for run: "<< *iter->second << " index of value: "<< iter->first << G4endl;
  iter++;
  }

//.. write histo histograms and close the file
   HistFile->Write();
   HistFile->Close();



 G4cout <<"MyLog:   Number of processed events:" << aRun->GetNumberOfEvent()
               << " events. " <<G4endl;
 G4cout << "MyLog:   End of run" << G4endl;
}

G4Run* MyRunAction::GenerateRun()
{
 return new MyRun();
}

